//+------------------------------------------------------------------+
//|                                                  GlobalTrend.mq4 |
//|                          Copyright  2008, HomeSoft-Tartan Corp. |
//|                                          http://www.fxexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft-Tartan Corp."
#property link      "spiky@transkeino.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Gold
#property indicator_width1  2

extern int t3_period = 21;
extern double      b = 0.7;
extern int        kb = 150;

//---- buffers
double BufferEur[];
double e1, e2, e3, e4, e5, e6, c1, c2, c3, c4, n, w1, w2, b2, b3;
double deur,teur,maxeur,mineur,aveur;
int ione,tf,mBar,cnt,pr;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufferEur);    
   tf=Period();
   b2=b*b;
   b3=b2*b;
   c1=-b3;
   c2=(3*(b2+b3));
   c3=-3*(2*b2+b+b3);
   c4=(1+3*b+b3+3*b2);
   n=t3_period;
   if (n<1) n=1;
   n = 1 + 0.5*(n-1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;   
   mBar=MathRound((24*60)/Period())*300;  
   if (Point>0.0002) pr=2; else pr=4;  
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {     
   if (Period()>1440) {Comment(" GT Indicator works on TF not higher D1");return(0);} //("        D1"
   
   if ((iHigh(NULL,tf,0)>maxeur) || (iLow(NULL,tf,0)<mineur))
   {
       maxeur=iHigh(NULL,tf,0);
       mineur=iLow(NULL,tf,0);
       
  for (cnt=mBar;cnt>=0;cnt--)
   { 
   if (maxeur<iHigh(NULL,tf,cnt)) maxeur=iHigh(NULL,tf,0);
   if (mineur>iLow(NULL,tf,cnt))  mineur=iLow(NULL,tf,0);
   } 
       aveur=NormalizeDouble( ((maxeur+mineur)/2),pr );
   }  
  for (ione=mBar; ione>=0; ione--)
   {
       deur = NormalizeDouble((iClose(NULL,tf,ione)/aveur),pr);
         e1 = w1*deur + w2*e1;
         e2 = w1*e1 + w2*e2;
         e3 = w1*e2 + w2*e3;
         e4 = w1*e3 + w2*e4;
         e5 = w1*e4 + w2*e5;
         e6 = w1*e5 + w2*e6;

       teur = c1*e6 + c2*e5 + c3*e4 + c4*e3;    
       BufferEur[ione] = teur;
   }
 
   return(0);
  }
//+------------------------------------------------------------------+